version: "3"
services:
  keycloak:
    image: jboss/keycloak:8.0.1
    container_name: KeycloakAuthService
    volumes:
      - //c/tmp:/tmp
    # Expose ensures a service is only exposed internally
    expose:
      - 8080
    environment:
      #Default admin Password
      - KEYCLOAK_PASSWORD=admin
      #Default admin UserName
      - KEYCLOAK_USER=admin
      #Import path for Keycloak Realm
      - KEYCLOAK_IMPORT=/tmp/BNM-Test.json
      #Required to allow reverse proxy redirect to keycloak client
      - PROXY_ADDRESS_FORWARDING=true

  testservicebackend:
    build: ./testservice/backend/
    volumes:
      - ./backend/src:/srv/app/backend/src
    expose:
      - 8080

  testservicefrontend:
    build:
      context: ./TestService/frontend/
      dockerfile: Dockerfile.prod
    expose:
      - 3000
    environment:
      # Lets ReactJS know to use PUBLIC_URL internally
      - CHOKIDAR_USEPOLLING=true
      - NODE_ENV=production
      # required for ReactJS websocket
      - WDS_SOCKET_PATH=.sockjs-node
      - REACT_APP_API_PATH=/testservice/api/

  gateway:
    build: ./BNM-Gateway/
    container_name: SpringCloudGateway
    ports:
      - 9500:9500
    environment:
      SPRING_PROFILES_ACTIVE: path
      # Test Service Frontend Static Files Route
      SPRING_CLOUD_GATEWAY_ROUTES[0]_ID: testservicefrontend
      SPRING_ClOUD_GATEWAY_ROUTES[0]_URI: http://testservicefrontend:3000
      SPRING_CLOUD_GATEWAY_ROUTES[0]_PREDICATES[0]: Path=/testservice/ui/**
      # Production Version Requires StripPrefix because of NGINX
      SPRING_CLOUD_GATEWAY_ROUTES[0]_FILTERS[0]: StripPrefix=2
      # Test Service Frontend Websocket Route
      SPRING_CLOUD_GATEWAY_ROUTES[1]_ID: testservicefrontend
      SPRING_ClOUD_GATEWAY_ROUTES[1]_URI: http://testservicefrontend:3000
      SPRING_CLOUD_GATEWAY_ROUTES[1]_PREDICATES[0]: Path=/testservice/ui/sockjs-node
      # Keycloak Route Auth Route
      SPRING_CLOUD_GATEWAY_ROUTES[2]_ID: keycloak
      SPRING_ClOUD_GATEWAY_ROUTES[2]_URI: http://keycloak:8080/auth/
      SPRING_CLOUD_GATEWAY_ROUTES[2]_PREDICATES[0]: Path=/auth/**
      # Test Service Backend
      SPRING_CLOUD_GATEWAY_ROUTES[3]_ID: testservicebackend
      SPRING_CLOUD_GATEWAY_ROUTES[3]_URI: http://testservicebackend:8080
      SPRING_CLOUD_GATEWAY_ROUTES[3]_PREDICATES[0]: Path=/testservice/api/**
      SPRING_CLOUD_GATEWAY_ROUTES[3]_FILTERS[0]: StripPrefix=2
